// Code generated by protoc-gen-go-grpc. DO NOT EDIT.
// versions:
// - protoc-gen-go-grpc v1.5.1
// - protoc             v5.29.3
// source: internal/module/autoflow/rpc/rpc.proto

package rpc

import (
	context "context"

	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.64.0 or later.
const _ = grpc.SupportPackageIsVersion9

const (
	AutoFlow_CloudEvent_FullMethodName = "/gitlab.agent.autoflow.rpc.AutoFlow/CloudEvent"
)

// AutoFlowClient is the client API for AutoFlow service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type AutoFlowClient interface {
	CloudEvent(ctx context.Context, in *CloudEventRequest, opts ...grpc.CallOption) (*CloudEventResponse, error)
}

type autoFlowClient struct {
	cc grpc.ClientConnInterface
}

func NewAutoFlowClient(cc grpc.ClientConnInterface) AutoFlowClient {
	return &autoFlowClient{cc}
}

func (c *autoFlowClient) CloudEvent(ctx context.Context, in *CloudEventRequest, opts ...grpc.CallOption) (*CloudEventResponse, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(CloudEventResponse)
	err := c.cc.Invoke(ctx, AutoFlow_CloudEvent_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// AutoFlowServer is the server API for AutoFlow service.
// All implementations must embed UnimplementedAutoFlowServer
// for forward compatibility.
type AutoFlowServer interface {
	CloudEvent(context.Context, *CloudEventRequest) (*CloudEventResponse, error)
	mustEmbedUnimplementedAutoFlowServer()
}

// UnimplementedAutoFlowServer must be embedded to have
// forward compatible implementations.
//
// NOTE: this should be embedded by value instead of pointer to avoid a nil
// pointer dereference when methods are called.
type UnimplementedAutoFlowServer struct{}

func (UnimplementedAutoFlowServer) CloudEvent(context.Context, *CloudEventRequest) (*CloudEventResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method CloudEvent not implemented")
}
func (UnimplementedAutoFlowServer) mustEmbedUnimplementedAutoFlowServer() {}
func (UnimplementedAutoFlowServer) testEmbeddedByValue()                  {}

// UnsafeAutoFlowServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to AutoFlowServer will
// result in compilation errors.
type UnsafeAutoFlowServer interface {
	mustEmbedUnimplementedAutoFlowServer()
}

func RegisterAutoFlowServer(s grpc.ServiceRegistrar, srv AutoFlowServer) {
	// If the following call pancis, it indicates UnimplementedAutoFlowServer was
	// embedded by pointer and is nil.  This will cause panics if an
	// unimplemented method is ever invoked, so we test this at initialization
	// time to prevent it from happening at runtime later due to I/O.
	if t, ok := srv.(interface{ testEmbeddedByValue() }); ok {
		t.testEmbeddedByValue()
	}
	s.RegisterService(&AutoFlow_ServiceDesc, srv)
}

func _AutoFlow_CloudEvent_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(CloudEventRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(AutoFlowServer).CloudEvent(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: AutoFlow_CloudEvent_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(AutoFlowServer).CloudEvent(ctx, req.(*CloudEventRequest))
	}
	return interceptor(ctx, in, info, handler)
}

// AutoFlow_ServiceDesc is the grpc.ServiceDesc for AutoFlow service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var AutoFlow_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "gitlab.agent.autoflow.rpc.AutoFlow",
	HandlerType: (*AutoFlowServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "CloudEvent",
			Handler:    _AutoFlow_CloudEvent_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "internal/module/autoflow/rpc/rpc.proto",
}
